aboutsummaryrefslogtreecommitdiff
path: root/scripts/updater.sh
diff options
context:
space:
mode:
authorZe Libertine Gamer <zlg@zlg.space>2016-10-14 05:02:55 -0700
committerZe Libertine Gamer <zlg@zlg.space>2016-10-14 05:02:55 -0700
commit7381b374e7508ece3584975f912032b8641d7ef0 (patch)
treeb23cb95af84e3b83b3257cb12c0eab6c570071a1 /scripts/updater.sh
parentCorrect pipe-handling behavior (diff)
downloadvgstash-7381b374e7508ece3584975f912032b8641d7ef0.tar.gz
vgstash-7381b374e7508ece3584975f912032b8641d7ef0.tar.bz2
vgstash-7381b374e7508ece3584975f912032b8641d7ef0.tar.xz
vgstash-7381b374e7508ece3584975f912032b8641d7ef0.zip
updater.sh: add recursion, error handling
Diffstat (limited to '')
-rwxr-xr-xscripts/updater.sh144
1 files changed, 101 insertions, 43 deletions
diff --git a/scripts/updater.sh b/scripts/updater.sh
index 47daa20..f240687 100755
--- a/scripts/updater.sh
+++ b/scripts/updater.sh
@@ -9,46 +9,104 @@ norm=""
BG="" # Green
BC="" # Cyan
BY="" # Yellow
-# Print the header first
-vgstash list | head -n 2
-# Let advanced users grep for a specific game
-vgstash list | grep -i "$1"
-# -ne omits the newline and accepts color escapes; handy!
-echo -ne "${BG}Which ID do you want to update?${norm} "
-read game_id
-echo "${game_id} selected."
-# Check to make sure $game_id is a number
-case $game_id in
- ''|*[!0-9]*)
- echo "No matching game found."
- exit 1
- ;;
- *)
- echo "Found game ID '${game_id}'!"
- ;;
-esac
-# TODO: make sure the game is actually in the db...
-echo -ne "${BG}Which field are you updating?\n[t]itle, [s]ystem, [o]wnership, [p]rogress: ${norm}"
-read game_field
-case $game_field in
- t|s)
- clause="string"
- ;;
- o)
- clause="y/n"
- ;;
- p)
- clause="[f]resh, [i]n-progress, [b]eaten, [c]omplete"
- ;;
- *)
- echo "Invalid"
- exit 1
- ;;
-esac
-echo -ne "${BG}What to?\n${clause}: ${norm}"
-read game_value
-# TODO: Put this into a loop/function
-echo "Running '${BC}vgstash update ${game_id} ${game_field} "${game_value}"${norm}'..."
-echo -ne "${BY}"
-vgstash update ${game_id} ${game_field} "${game_value}"
-echo -ne "${norm}"
+
+again=0
+gamesrc=""
+
+gid_check() {
+ if [[ $# == 1 ]]; then
+ case $game_id in
+ ''|*[!0-9]*)
+ echo "ID is not a number."
+ exit 1
+ ;;
+ *)
+ # Check for its existence
+ result=$(vgstash list -r | grep "^${game_id}|")
+ if [[ -n $result ]]; then
+ echo "Found game ID '${game_id}'!"
+ else
+ echo "ID not found in vgstash database."
+ exit 1
+ fi
+ ;;
+ esac
+ fi
+}
+
+field_update() {
+ echo -ne "${BG}Which field are you updating?\n[t]itle, [s]ystem, [o]wnership, [p]rogress: ${norm}"
+ read game_field
+ case $game_field in
+ t|s)
+ clause="string"
+ ;;
+ o)
+ clause="y/n"
+ ;;
+ p)
+ clause="[f]resh, [i]n-progress, [b]eaten, [c]omplete"
+ ;;
+ *)
+ echo "Invalid"
+ exit 1
+ ;;
+ esac
+ echo -ne "${BG}What to?\n${clause}: ${norm}"
+ read game_value
+ # TODO: Put this into a loop/function
+ echo "Running '${BC}vgstash update ${game_id} ${game_field} "${game_value}"${norm}'..."
+ echo -ne "${BY}"
+ vgstash update ${game_id} ${game_field} "${game_value}"
+ echo -ne "${norm}"
+ run_again
+}
+
+run_again() {
+ echo -ne "${BG}Do you want to edit another game?${norm} "
+ read again
+ case $again in
+ y|yes)
+ main
+ ;;
+ n|no)
+ exit
+ ;;
+ esac
+}
+
+game_search() {
+ if [[ $# == 0 ]]; then
+ echo -ne "${BG}Game title to search for:${norm} "
+ read gamesrc
+ else
+ gamesrc="$1"
+ fi
+ # Print the header first
+ vgstash list | head -n 2
+ vgstash list | grep -i "$gamesrc"
+ # -ne omits the newline and accepts color escapes; handy!
+ echo -ne "${BG}Which ID do you want to update?${norm} "
+ read game_id
+ echo "${game_id} selected."
+ # Check to make sure $game_id is a number
+ gid_check $game_id
+ field_update $game_id
+}
+
+main() {
+ case $# in
+ 0)
+ game_search
+ ;;
+ 1)
+ game_search "$1"
+ ;;
+ *)
+ echo "This script accepts zero or one arguments."
+ exit
+ ;;
+ esac
+}
+
+main $*
RESS dictionaries in the vgstash package. An empty notes field will result in a line ending with a pipe and no whitespace following it. 2018-09-08Add remaining filters to vgstash packagezlg1-2/+11 2018-09-04Update LICENSE to match setup.pyzlg1-80/+67 Whoops. 2018-09-03Branch off from master with pytest, tox, clickzlg16-778/+779 This commit is huge, but contains everything needed for a "proper" build system built on pytest + tox and a CLI built with click. For now, this branch will contain all new vgstash development activity until it reaches feature parity with master. The CLI is installed to pip's PATH. Only the 'init', 'add', and 'list' commands work, with only two filters. This is pre-alpha software, and is therefore not stable yet. 2018-03-18Flesh out filter types and ownership statuszlg3-82/+144 It's time for a refactor to a module; the functionality and interface are clashing. 2018-03-18README.mdown: break line correctlyzlg1-1/+1 2018-03-18add 'playlog' list filterzlg2-2/+9 This filter is used to get an idea of which games you're currently playing through, so you can prioritize games to play when you're bored and detect it when you've beaten a game but haven't marked it as such. 2018-03-13Update helpers a bitzlg1-2/+9 At present, user modification is needed to make these seamless. vgup() may need to be axed in favor of telling the user to make an alias. 2018-03-13Make VGSTASH_DB_LOCATION point to a filezlg2-21/+20 It used to point to a directory, which would then look for .vgstash.db. This behavior was kind of backwards and I don't remember why I did it that way. This change gives users more control over where they put their DB. Be sure to update your environment variable if you have it set! 2016-11-18Remove settings from helpers.shZe Libertine Gamer1-5/+0 Sourcing them in .bash_profile screws up login if they're set. 2016-11-15Correct phrasing in README.Ze Libertine Gamer1-4/+4 2016-11-13DerpZe Libertine Gamer1-0/+1 2016-11-03Improve error handling in shell scriptsZe Libertine Gamer4-3/+23 2016-10-24Correct run_again, add recursionZe Libertine Gamer1-0/+4 Loops and functions -- oh my, what a useful combination. :) 2016-10-21Add quotes to correct behavior for arglistZe Libertine Gamer1-1/+1 2016-10-14updater.sh: add recursion, error handlingZe Libertine Gamer1-43/+101 2016-10-14Correct pipe-handling behaviorZe Libertine Gamer1-1/+9 2016-10-12Clarify a method to move between platformsZe Libertine Gamer1-2/+5 Also correct a typo.